//
// Test 04e par AZERTix : plugin video pour K!TV-XP 1.2.5.0 pour dcoder le Discret (Canal+ Wallonie notamment).
//
// [~ 04/01/2002 ~] Converted by AZERTix from BorgTV's plugin AZERTix9eMMX :
// [~ 04/01/2002 ~]   Restriction : no user interface => no manual tuning options available
	// [~ 25/08/2000 ~] Test by AZERTix, merging Odd and Even frames, to determine Discret displacements
	// [~ 17/09/2000 ~] Add of chrominance special logic and adaptation of delta values (odd values now supported)
	// [~ 23/09/2000 ~] Add line comparison option
	// [~ 27/09/2000 ~] Change beginning of lines detection method
	// [~ 03/10/2000 ~] Beginning of lines detection and lines comparison both used + processing optimization
	// [~ 06/10/2000 ~] Beginning of line detection simplified
	// [~ 06/10/2000 ~] Add reference line selection and both directions line comparison (no more beginning of line detection)
	// [~ 09/10/2000 ~] Better chrominance processing + general processing optimization
	// [~ 14/10/2000 ~] Better reference line selection
	// [~ 19/10/2000 ~] Add performance tuning option
	// [~ 21/10/2000 ~] Add delay for stability (no more crash ?)
	// [~ 28/10/2000 ~] Add VCR mode
	// [~ 01/11/2000 ~] Better line comparison (sum diff**2)
	// [~ 01/11/2000 ~] Add position verification after line comparison
	// [~ 16/11/2000 ~] Add beginning of line detection option
	// [~ 19/11/2000 ~] Replace beginning of line detection processing (Sum -> Max)
	// [~ 19/11/2000 ~] Use static variables wherever possible (speed up processing)
	// [~ 10/01/2001 ~] Add MMX processing to speed-up comparison processings
	// [~ 30/12/2001 ~] Remove VCR mode and some unusable comments
// [~ 15/01/2002 ~] Add chrominance special processing and adapt shifting values
// [~ 16/01/2002 ~] Replace duplicate MMX processing by a single routine
// [~ 16/01/2002 ~] Remove some unused definitions and comments
// [~ 20/01/2002 ~] Upgrade from K!TV 1.0.0.1 to K!TV 1.0.1.2
// [~ 26/01/2002 ~] Bug correction for reference line shift
// [~ 29/01/2002 ~] Bug correction to set 's' variable before line place verification
// [~ 09/02/2002 ~] Upgrade from K!TV 1.0.1.2 to K!TV 1.0.2.5 (no more BUG in K!TV : now 288 lines also in PAL)
// [~ 10/02/2002 ~] Upgrade from K!TV 1.0.2.5 to K!TV 1.1.0.0
// [~ 18/02/2002 ~] Add reverse side lines comparison before standard processing
// [~ 05/01/2003 ~] Compare only 1 MMX block on 2 to speed-up processing
// [~ 05/01/2003 ~] Bug correction for FullField=0 in DoStuff()
// [~ 05/01/2003 ~] Hide special lines (E0, E1, E287, O0, O286, O287)
// [~ 05/01/2003 ~] Force end of lines to be black (green by default)
// [~ 14/01/2003 ~] Upgrade from K!TV 1.1.0.0 to K!TV 1.2.5.0 (from KAzertix03d2)
// [~ 14/01/2003 ~] Correct Y information displayed in GetStatus()
// [~ 14/01/2003 ~] Force VIA_FIX_X to use even Delta values (Delta1 = 12, Delta2 = 24)
// [~ 18/01/2003 ~] Skip reverse side lines comparison when reference line is found
// [~ 19/01/2003 ~] Move end of line preprocessing from DLL_THREAD_ATTACH to Start()
//// [~ 19/01/2003 ~] Create KAzertix05 from KAzertix03d2
// [~ 19/01/2003 ~] Compare all MMX blocks for last lines comparison processing (partial comparison only used for reverse side)
//// [~ 19/01/2003 ~] Mark correct lines and skip processing for marked lines
//// [~ 19/01/2003 ~] Add factor for first pixels in lines comparison
// [~ 26/01/2003 ~] Add intermediate array to merge current Even and Odd frames before comparing lines (from KAzertix05)
// [~ 26/01/2003 ~] Add bFirstEvenSkipped variable to avoid black screen due to uninitialized frame display
//// [~ 01/02/2003 ~] Tuning for BLumT1 and BLumT2
// [~ 01/02/2003 ~] Leave plugin properly when environment not suitable
// [~ 01/02/2003 ~] Remove unnecessary code (lines comparison from bottom to central reference)

// ======================================================================================

// Input resolution must be 768*576 (576 = 288 * 2)

// ======================================================================================

// Video format is YUY2 (also named YCrCb 4:2:2), each pixel uses 2 bytes as follows :
//
//		Pixel[n]	= Cb[n] + Y[n]
//		Pixel[n+1]	= Cr[n] + Y[n+1]
//
//		Where Y is luminance (mainly Green) and C is chrominance
//		(Cb is a Bleue reference relative to Y and Cr is a Red reference relative to Y).
//
// A special logic is thus mandatory when shifting for an odd number of pixels in a line.

// ======================================================================================

#include <stdio.h> // utilisation de sprintf
#include "PluginVideo.h" // provient du SDK
#include "ResCommun.h"   // provient du SDK

CRITICAL_SECTION PluginVideoCrit; // pour ne pas faire planter le plugin

/* Current frame : 
 K!TV utilise plusieur buffers o il stocke la source,
 cette variable est actualise par doModif()
 et ensuite il faudra aller chercher le bon buffer
 (voir ty*CurrentFrame dans la source).
*/
static int CurrentFrame;	

/* Current Even and Odd frames shiftings */
static int cFrame[576] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
						  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
static short *pLA[576]; // pointer to merge vidPlug.EvenLines[CurrentFrame][*] and vidPlug.OddLines[CurrentFrame][*]
static short *LA; // Line Address field pointer (1 pixel = 2 bytes, chrominance uses 2 pixels)
static int y; // line index
static int x; // pixel index in current line

static bool bFirstEvenSkipped; // to avoid display of uninitialized Even frame (first one)

static int lastDX; // dx value from previous line
static char *plastDX = (char *)&lastDX; // MMX pointer on lastDX
static long diffB[3][370]; // MMX blocks, 3*array of 32 bits (< (2 pixels)**2 added using MMX), only 184/370 used (1 MMX block on 2)
static char *pdiffB0 = (char *)&diffB[0][0]; // MMX pointer on diffB0

/*
 Variables utilises partout
 maxY = number of lines in each frame
 maxX = vidPlug.CurrentX
*/
static int maxY = 288, maxX = 696; // capture resolution

// Pr - dclarations
BOOL APIENTRY PluginSetupProc(HWND hDlg, UINT message, UINT wParam, LONG lParam);
BOOL Start();
BOOL Stop();
void ShowDialog();
void InitStuff();
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer);
void PrepareUpdateScreen(BOOL);
void CheckStuff(void);
void Reset(BOOL ResetALL);
void GetStatus(char * Text, BOOL Nb);
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay);
HMENU GetPluginMenu(BOOL ContextMenu);
void SetLow(unsigned char bBrightness);
BOOL AutoMovieBoostFound();
BOOL DetecteSignal(BYTE *pVBI);

// Cration d'une instance de l'objet de type QuenotteTV_VideoPlugin
QuenotteTV_VideoPlugin vidPlug;

// Chargement et dchargement de la DLL
BOOL APIENTRY DllMain(HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved)
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			InitializeCriticalSection(&PluginVideoCrit);
			break;
		case DLL_THREAD_ATTACH:
			break;
		case DLL_THREAD_DETACH:
			break;
		case DLL_PROCESS_DETACH:
			DeleteCriticalSection(&PluginVideoCrit);
			break;
    }
    return TRUE;
}

// Dclaration de cette instance  K!TV.exe
extern "C" __declspec( dllexport )QuenotteTV_VideoPlugin * GetVPlugin()
{
	vidPlug.version = VIDEO_PLUGIN_VERSION;
	vidPlug.description = "KAzertix04e (AZERTix)";
	vidPlug.VIA_FIX = true; // force X acquisition resolution
	vidPlug.VIA_FIX_X = maxX; // set X acquisition resolution
	vidPlug.MovieBoost = 0;
	vidPlug.accel = false;
	vidPlug.NbAccel = 0;

	vidPlug.Start = Start;
	vidPlug.Stop = Stop;
	vidPlug.ShowDialog = ShowDialog;

	vidPlug.InitStuff = InitStuff;
	vidPlug.DoStuff = DoStuff;
	vidPlug.CheckStuff = CheckStuff;

	vidPlug.GetStatus = GetStatus;
	vidPlug.ProcessMessage = ProcessMessage;
	vidPlug.GetPluginMenu = GetPluginMenu;
	vidPlug.SetLow = SetLow;
	vidPlug.AutoMovieBoostFound = AutoMovieBoostFound;
	vidPlug.DetecteSignal = DetecteSignal;
	
//	Init(); // initialisation du chargement du fichier .INI
	
	return &vidPlug;
}

/*
 Start : appel quand on appuie sur F3 ou ALT+F3
 renvoie false si a ne marche pas
*/
BOOL Start()
{
	// Set end of lines to black (green by default) in all buffers
	for (CurrentFrame = 0; CurrentFrame < 5; CurrentFrame++)
		for (y = 0; y < 288; y++)
		{
			LA = vidPlug.OddLines[CurrentFrame][y];
			for (x = maxX; x < maxX + 24; x++) // maxX + delta2
			{
				LA[x] = short(0x8030); // set pixel to black
			}
			LA = vidPlug.EvenLines[CurrentFrame][y];
			for (x = maxX; x < maxX + 24; x++) // maxX + delta2
			{
				LA[x] = short(0x8030); // set pixel to black
			}
		}

	bFirstEvenSkipped = false; // reset first Even frame display trigger

	return true;
}

/*
 Stop : appel quand on appuie sur F2
 renvoie false si a ne marche pas
*/
BOOL Stop()
{
	return true;
}

/*
 Dialog box : pour changer les options
*/
void ShowDialog()
{
	MessageBox(vidPlug.hwndParent,"(o:   Un homme AZERTY en vaut deux !   :o)","Dialog box de Show Dialog",MB_OK);
}

/*
 InitStuff : lanc juste aprs Start
*/
void InitStuff()
{	
}
	
/*
 Used by DecryptFrame : get max luminance in a group of pixels
*/
int dx_Max(int dx, short *p, int xx)	// get max pixel luminance from dx position for (xx-2) pixels
												// dx = starting pixel index
												// p = pointer to current line
												// xx = #pixels to process + 2 (and end pixel index)
{
	static int x; // pixel index in current line
	static unsigned char lum; // pixel luminance
	static unsigned char max; // maximum pixel luminance

	max = 0; // init maxmimum pixel luminance
	xx += dx - 2; // set end pixel index
	for (x = dx; x < xx; x++) // get max pixel luminance from dx position for (xx-2) pixels
	{
		lum = p[x] & 0x00ff; // get pixel luminance
		if (lum > max)
			max = lum; // save max luminance
	}

	return max; // return max pixel luminance
}

/*
 Used by DecryptFrame : sum luminance for a group of pixels
*/
int dx_Sum(int dx, short *p, int xx)	// sum (xx-1) pixels luminance from dx position
												// dx = starting pixel index
												// p = pointer to current line
												// xx = #pixels to process + 1 (and end pixel index)
{
	static int x; // pixel index in current line
	static int sum; // sum counter

	sum = 0; // clear sum
	xx += dx - 1; // set end pixel index
	for (x = dx; x < xx; x++) // sum (xx-1) pixels luminance from dx position
		sum += p[x] & 0x00ff; // add next pixel luminance

	return sum; // return sum result
}

/*
 Used by DecryptFrame : MMX optimized line comparing for 3 possible line positions (all pixels compared)
*/
void MMX_cmp_full(short *s, short *ref)	// MMX luminance comparing
										// s = source field pointer (1 pixel = 2 bytes, chrominance uses 2 pixels)
										// ref = reference source field pointer for comparing
{
	static __int64 MMXmaskY = 0x00ff00ff00ff00ff; // MMX mask for luminance
	static char *pMMXmaskY = (char *)&MMXmaskY; // MMX pointer on MMX mask for luminance

	__asm
	{ // use MMX for lines comparison
		mov   eax,dword ptr[pMMXmaskY]		// eax contains MMXmaskY address
		movq  mm7,qword ptr[eax]			// mm7 contains luminance mask
		movd  mm6,dword ptr[ref]			// mm6 contains ref address (reference compare source)
		mov   eax,dword ptr[plastDX]		// eax contains lastDX address
		mov   eax,[eax]						// eax contains lastDX (in pixels)
		shl   eax,1  						// eax contains lastDX (in bytes)
		movd  mm4,eax						// mm4 contains lastDX (in bytes)
		paddw mm6,mm4  						// mm6 contains ref address + lastDX (in bytes)
		movd  mm5,dword ptr[s]				// mm5 contains s address (source)
		mov   edi,dword ptr[pdiffB0]		// edi contains diffB0 address (output array)
		mov   ecx,168						// 168 = (696-24)/4 = (maxX-delta2)/4 (4 pixels in 64 bits MMX block)

		align 16
MMXnext:
		// Load mm0 with next 4 reference pixels
		movd  esi,mm6						// esi contains ref address
		movq  mm0,qword ptr[esi]			// mm0 contains 4 next reference pixels
		pand  mm0,mm7						// keep luminances only
		// Load mm1 with next 4 pixels from s0 (no delta)
		movd  esi,mm5						// esi contains s address
		movq  mm1,qword ptr[esi]			// mm1 contains 4 next pixels from s0
		pand  mm1,mm7						// keep luminances only
		// Load mm2 with next 4 pixels from s1 (delta1)
		movq  mm2,qword ptr[esi+12*2]		// mm2 contains 4 next pixels from s1
		pand  mm2,mm7						// keep luminances only
		// Load mm3 with next 4 pixels from s2 (delta2)
		movq  mm3,qword ptr[esi+24*2]		// mm2 contains 4 next pixels from s2
		pand  mm3,mm7						// keep luminances only

		// Compute ((s0 luminance)-(ref luminance))**2 + idem next pixel in MMX block
		psubw mm1,mm0						// mm1 contains luminance difference
		pmaddwd mm1,mm1						// mm1 contains 2 times 32 bits sum
		// Compute ((s1 luminance)-(ref luminance))**2 + idem next pixel in MMX block
		psubw mm2,mm0						// mm2 contains luminance difference
		pmaddwd mm2,mm2						// mm2 contains 2 times 32 bits sum
		// Compute ((s2 luminance)-(ref luminance))**2 + idem next pixel in MMX block
		psubw mm3,mm0						// mm3 contains luminance difference
		pmaddwd mm3,mm3						// mm3 contains 2 times 32 bits sum

		// Write results in diffB0, diffB1 and diffB2 array
		movq  qword ptr[edi],mm1			// write mm1 in diffB0
		movq  qword ptr[edi+370*4],mm2		// write mm2 in diffB1
		movq  qword ptr[edi+370*4*2],mm3	// write mm3 in diffB2

		// Increment ref pointer
		movd  esi,mm6						// esi contains ref address
		add   esi,8							// add MMX block length to esi (8 bytes)
		movd  mm6,esi						// mm6 contains incremented ref address
		// Increment s pointer
		movd  esi,mm5						// esi contains s address
		add   esi,8							// add MMX block length to esi (8 bytes)
		movd  mm5,esi						// mm5 contains incremented s address
		// Increment diffB0 pointer
		add   edi,8							// edi contains incremented diffB0 address

		dec   ecx							// decrement loop counter
		jne   near MMXnext					// loop until ecx=0

		emms								// quit MMX mode
	}
}

/*
 Used by DecryptFrame : MMX optimized line comparing for 3 possible line positions (only some pixels compared)
*/
void MMX_cmp(short *s, short *ref)	// MMX luminance comparing
										// s = source field pointer (1 pixel = 2 bytes, chrominance uses 2 pixels)
										// ref = reference source field pointer for comparing
{
	static __int64 MMXmaskY = 0x00ff00ff00ff00ff; // MMX mask for luminance
	static char *pMMXmaskY = (char *)&MMXmaskY; // MMX pointer on MMX mask for luminance

	__asm
	{ // use MMX for lines comparison
		mov   eax,dword ptr[pMMXmaskY]		// eax contains MMXmaskY address
		movq  mm7,qword ptr[eax]			// mm7 contains luminance mask
		movd  mm6,dword ptr[ref]			// mm6 contains ref address (reference compare source)
		mov   eax,dword ptr[plastDX]		// eax contains lastDX address
		mov   eax,[eax]						// eax contains lastDX (in pixels)
		shl   eax,1  						// eax contains lastDX (in bytes)
		movd  mm4,eax						// mm4 contains lastDX (in bytes)
		paddw mm6,mm4  						// mm6 contains ref address + lastDX (in bytes)
		movd  mm5,dword ptr[s]				// mm5 contains s address (source)
		mov   edi,dword ptr[pdiffB0]		// edi contains diffB0 address (output array)
		mov   ecx,84						// 84 = (696-24)/4 = (maxX-delta2)/4 (4 pixels in 64 bits MMX block) /2 (compare 1 MMX block on 2)

		align 16
MMXnext:
		// Load mm0 with next 4 reference pixels
		movd  esi,mm6						// esi contains ref address
		movq  mm0,qword ptr[esi]			// mm0 contains 4 next reference pixels
		pand  mm0,mm7						// keep luminances only
		// Load mm1 with next 4 pixels from s0 (no delta)
		movd  esi,mm5						// esi contains s address
		movq  mm1,qword ptr[esi]			// mm1 contains 4 next pixels from s0
		pand  mm1,mm7						// keep luminances only
		// Load mm2 with next 4 pixels from s1 (delta1)
		movq  mm2,qword ptr[esi+12*2]		// mm2 contains 4 next pixels from s1
		pand  mm2,mm7						// keep luminances only
		// Load mm3 with next 4 pixels from s2 (delta2)
		movq  mm3,qword ptr[esi+24*2]		// mm2 contains 4 next pixels from s2
		pand  mm3,mm7						// keep luminances only

		// Compute ((s0 luminance)-(ref luminance))**2 + idem next pixel in MMX block
		psubw mm1,mm0						// mm1 contains luminance difference
		pmaddwd mm1,mm1						// mm1 contains 2 times 32 bits sum
		// Compute ((s1 luminance)-(ref luminance))**2 + idem next pixel in MMX block
		psubw mm2,mm0						// mm2 contains luminance difference
		pmaddwd mm2,mm2						// mm2 contains 2 times 32 bits sum
		// Compute ((s2 luminance)-(ref luminance))**2 + idem next pixel in MMX block
		psubw mm3,mm0						// mm3 contains luminance difference
		pmaddwd mm3,mm3						// mm3 contains 2 times 32 bits sum

		// Write results in diffB0, diffB1 and diffB2 array
		movq  qword ptr[edi],mm1			// write mm1 in diffB0
		movq  qword ptr[edi+370*4],mm2		// write mm2 in diffB1
		movq  qword ptr[edi+370*4*2],mm3	// write mm3 in diffB2

		// Increment ref pointer
		movd  esi,mm6						// esi contains ref address
		add   esi,8*2							// add MMX block length to esi (8 bytes) * 2
		movd  mm6,esi						// mm6 contains incremented ref address
		// Increment s pointer
		movd  esi,mm5						// esi contains s address
		add   esi,8*2							// add MMX block length to esi (8 bytes) * 2
		movd  mm5,esi						// mm5 contains incremented s address
		// Increment diffB0 pointer
		add   edi,8							// edi contains incremented diffB0 address

		dec   ecx							// decrement loop counter
		jne   near MMXnext					// loop until ecx=0

		emms								// quit MMX mode
	}
}

/*
 Dcodage Discret de la frame en cours
*/
void DecryptFrame()
{
	static short *s; // source field pointer (1 pixel = 2 bytes, chrominance uses 2 pixels)
	static int dx; // computed line shifting to apply to descramble current line
	static int ldx; // left margin if any
	static int delta1 = 12; // 1 shift reference
	static int delta2 = 24; // 2 shifts reference

	static int DFminY = 4; // starting line for reference search
	static int DFmaxY; // ending line for reference search + 1
	static int BlackLum; // reference black luminance
	static int BLumT1; // black luminance threshold 1
	static int BLumT2; // black luminance threshold 2
	static int MaxLum; // max luminance reference
	static int MaxLumY; // max luminance line index
	static int CLum; // current luminance reference

	static int diffP0, diffP1, diffP2; // pixel (luminance) difference for delta 0, 1 and 2
	static long sumL0, sumL1, sumL2; // line sum for delta 0, 1 and 2
//	static int SumFact = 5; // ponderation factor for comparison sum
//	static int PondLength = 10; // ponderation length (12 = delta2 / 2 - 2)

	static int dx_S0, dx_S1, dx_S2; // sum reference for delta 0, 1 and 2

	DFmaxY = (maxY * 2) - 4; // set ending line for reference search + 1

	ldx = 0; // use 0 as margin (in pixels) : no user interface now

	s = pLA[575]; // use last line as reference (begins with black)
	BlackLum = dx_Sum(0, s, delta1); // get reference black luminance
	BLumT1 = BlackLum + (BlackLum >> 1) + (BlackLum >> 2); // reference line validation threshold
	BLumT2 = (BlackLum << 1) + (BlackLum >> 1); // correct lines validation threshold

	MaxLum = -1; // clear max luminance
	for (y = DFminY; y < DFmaxY; y++) // search best reference line and mark all correct lines
	{
		s = pLA[y]; // s points to source field

		CLum = dx_Sum(ldx, s, delta1); // get current luminance reference

//		if (CLum > BLumT2)
//		{
//			cFrame[y] = 200; // mark line as correct (already in the correct position)
//
/* Display marked line
			for (x = ldx+50; x < ldx+60; x++)
				s[x] = short(0x00FF);
*/
//		}

		if (CLum > MaxLum)
		{
			MaxLum = CLum; // save max luminance
			MaxLumY = y; // save max luminance line index
		}
	}

	if (MaxLum < BLumT1) // if MaxLumY not correct
		MaxLumY = maxY; // then use maxY as reference line
	else
	{ // reference line found
		cFrame[MaxLumY] = ldx; // save shift value 0 for reference line (no shift)
		goto NoCmp2; // skip duplicate comparisons when reference line found
	}

	/*
	** Compare lines from beginning of frame to MaxLumY
	*/
	lastDX = ldx; // init last dx value
	for (y = DFminY+1; y <= MaxLumY; y++) // align following lines
	{
		s = pLA[y]; // s points to adjacent line to be placed correctly
		MMX_cmp(s,pLA[y-1]); // MMX possible line positions comparing

		sumL0 = sumL1 = sumL2 = 0; // clear no shift, 1 shift and 2 shifts sum
		for (x = 0; x < 168; x++) // 168 = (maxX - delta2) / 4
		{ // sum MMX results
			sumL0 += diffB[0][x]; // add next 32 bits for no shit
			sumL1 += diffB[1][x]; // add next 32 bits for 1 shift
			sumL2 += diffB[2][x]; // add next 32 bits for 2 shifts
		}

		if (sumL0 < sumL1)
			if (sumL2 < sumL0)
				dx = delta2; // (sumL0<sumL1) and (sumL2<sumL0) => sumL2 is smallest => DX=delta2
			else
				dx = 0; // (sumL0<sumL1) and (sumL2>=sumL0) => sumL0 is smallest => DX=0
		else
			if (sumL1 < sumL2)
				dx = delta1; // (sumL0>=sumL1) and (sumL1<sumL2) => sumL1 is smallest => DX=delta1
			else
				dx = delta2; // (sumL0>=sumL1) and (sumL1>=sumL2) => sumL2 is smallest => DX=delta2

//NoCmpDOWN2:
		dx_S2 = dx_Sum(ldx+delta2, s, delta1); // get delta2 sum reference
		dx_S1 = dx_Sum(ldx+delta1, s, delta1); // get delta1 sum reference
		dx_S0 = dx_Sum(ldx, s, delta1); // get delta0 sum reference
		if ((dx == delta2) & (dx_S2 > BLumT1) & (dx_S1 > dx_S2-(dx_S2>>4)))
			dx = delta1; // correct dx when necessary
		if ((dx == delta1) & (dx_S1 > BLumT1) & (dx_S0 > dx_S1-(dx_S1>>4)))
			dx = 0; // correct dx when necessary

		cFrame[y] = dx + ldx; // save determined shift value for current line
		lastDX = dx; // save dx value
	}

NoCmp2:
	/*
	** Compare lines from MaxLumY to beginning of frame
	*/
	lastDX = cFrame[MaxLumY] - ldx; // init last dx value
	for (y = MaxLumY-1; y >= 0; y--) // align preceding lines
	{
		if (cFrame[y] == 200)
		{
			dx = 0; // Force no shift
			goto NoProcessUP1; // Skip processing for marked lines
		}

		s = pLA[y]; // s points to adjacent line to be placed correctly
		MMX_cmp_full(s,pLA[y+1]); // MMX possible line positions comparing

		/* No user interface now
		if (pp->key1)
		{ // beginning of line detection
			dx = 2; // flag dx as not determined
			if (dx_Max(ldx+delta2, s, delta1) > pp->level1)
				dx = delta2; // 2 shifts
			if (dx_Max(ldx+delta1, s, delta1) > pp->level1)
				dx = delta1; // 1 shift
			if (dx_Max(ldx, s, delta1) > pp->level1)
				dx = 0; // no shift
			if (dx != 2)
				goto NoCmpUP1;
		}
		*/

		sumL0 = sumL1 = sumL2 = 0; // clear no shift, 1 shift and 2 shifts sum
		for (x = 0; x < 336; x++) // 336 = (maxX - delta2) / 2
		{ // sum MMX results
			sumL0 += diffB[0][x]; // add next 32 bits for no shit
			sumL1 += diffB[1][x]; // add next 32 bits for 1 shift
			sumL2 += diffB[2][x]; // add next 32 bits for 2 shifts
		}
//		for (x = 0; x < PondLength; x++)
//		{ // add ponderation for first pixels
//			sumL0 += diffB[0][x] * SumFact;
//			sumL1 += diffB[1][x] * SumFact;
//			sumL2 += diffB[2][x] * SumFact;
//		}

		if (sumL0 < sumL1)
			if (sumL2 < sumL0)
				dx = delta2; // (sumL0<sumL1) and (sumL2<sumL0) => sumL2 is smallest => DX=delta2
			else
				dx = 0; // (sumL0<sumL1) and (sumL2>=sumL0) => sumL0 is smallest => DX=0
		else
			if (sumL1 < sumL2)
				dx = delta1; // (sumL0>=sumL1) and (sumL1<sumL2) => sumL1 is smallest => DX=delta1
			else
				dx = delta2; // (sumL0>=sumL1) and (sumL1>=sumL2) => sumL2 is smallest => DX=delta2

//NoCmpUP1:
		dx_S2 = dx_Sum(ldx+delta2, s, delta1); // get delta2 sum reference
		dx_S1 = dx_Sum(ldx+delta1, s, delta1); // get delta1 sum reference
		dx_S0 = dx_Sum(ldx, s, delta1); // get delta0 sum reference
		if ((dx == delta2) & (dx_S2 > BLumT1) & (dx_S1 > dx_S2-(dx_S2>>4)))
			dx = delta1; // correct dx when necessary
		if ((dx == delta1) & (dx_S1 > BLumT1) & (dx_S0 > dx_S1-(dx_S1>>4)))
			dx = 0; // correct dx when necessary

NoProcessUP1:
		cFrame[y] = dx + ldx; // save determined shift value for current line
		lastDX = dx; // save dx value
	}

	/*
	** Compare lines from MaxLumY to end of frame
	*/
	lastDX = cFrame[MaxLumY] - ldx; // init last dx value
	for (y = MaxLumY+1; y < (maxY*2); y++) // align following lines
	{
		if (cFrame[y] == 200)
		{
			dx = 0; // Force no shift
			goto NoProcessDown1; // Skip processing for marked lines
		}

		s = pLA[y]; // s points to adjacent line to be placed correctly
		MMX_cmp_full(s,pLA[y-1]); // MMX possible line positions comparing

		/* No user interface now
		if (pp->key1)
		{ // beginning of line detection
			dx = 2; // flag dx as not determined
			if (dx_Max(ldx+delta2, s, delta1) > pp->level1)
				dx = delta2; // 2 shifts
			if (dx_Max(ldx+delta1, s, delta1) > pp->level1)
				dx = delta1; // 1 shift
			if (dx_Max(ldx, s, delta1) > pp->level1)
				dx = 0; // no shift
			if (dx != 2)
				goto NoCmpDOWN1;
		}
		*/

		sumL0 = sumL1 = sumL2 = 0; // clear no shift, 1 shift and 2 shifts sum
		for (x = 0; x < 336; x++) // 336 = (maxX - delta2) / 2
		{ // sum MMX results
			sumL0 += diffB[0][x]; // add next 32 bits for no shit
			sumL1 += diffB[1][x]; // add next 32 bits for 1 shift
			sumL2 += diffB[2][x]; // add next 32 bits for 2 shifts
		}
//		for (x = 0; x < PondLength; x++)
//		{ // add ponderation for first pixels
//			sumL0 += diffB[0][x] * SumFact;
//			sumL1 += diffB[1][x] * SumFact;
//			sumL2 += diffB[2][x] * SumFact;
//		}

		if (sumL0 < sumL1)
			if (sumL2 < sumL0)
				dx = delta2; // (sumL0<sumL1) and (sumL2<sumL0) => sumL2 is smallest => DX=delta2
			else
				dx = 0; // (sumL0<sumL1) and (sumL2>=sumL0) => sumL0 is smallest => DX=0
		else
			if (sumL1 < sumL2)
				dx = delta1; // (sumL0>=sumL1) and (sumL1<sumL2) => sumL1 is smallest => DX=delta1
			else
				dx = delta2; // (sumL0>=sumL1) and (sumL1>=sumL2) => sumL2 is smallest => DX=delta2

//NoCmpDOWN1:
		dx_S2 = dx_Sum(ldx+delta2, s, delta1); // get delta2 sum reference
		dx_S1 = dx_Sum(ldx+delta1, s, delta1); // get delta1 sum reference
		dx_S0 = dx_Sum(ldx, s, delta1); // get delta0 sum reference
		if ((dx == delta2) & (dx_S2 > BLumT1) & (dx_S1 > dx_S2-(dx_S2>>4)))
			dx = delta1; // correct dx when necessary
		if ((dx == delta1) & (dx_S1 > BLumT1) & (dx_S0 > dx_S1-(dx_S1>>4)))
			dx = 0; // correct dx when necessary

NoProcessDown1:
		cFrame[y] = dx + ldx; // save determined shift value for current line
		lastDX = dx; // save dx value
	}

/* Display reference line
	s = pLA[MaxLumY];
	for (x = ldx+30; x < ldx+50; x++)
		s[x] = short(0xffff);
*/
}

/*
 Appel  chaque image (aprs acquisition) : dtermination des dcalages pour la frame en cours
*/
void DoStuff(BOOL bIsOdd, BOOL *UpdateBuffer, BOOL *ViewBuffer)
{
	static int dx; // current line shifting
	static short **pOutLA; // pointer on Line Address to map vidPlug.OutOddLines[CurrentFrame][*] or vidPlug.OutEvenLines[CurrentFrame][*]

	CurrentFrame = vidPlug.CurrentFrame; // save current frame buffer reference
	
	if ((vidPlug.CurrentX < 650) | (!vidPlug.FullField))
	{ // Leave plugin
		*UpdateBuffer = false; // don't copy current buffer
		*ViewBuffer = false; // don't show buffers
		return; // input resolution must be 768*576 (576 = 288 * 2), VIA_FIX_X may be lesser; FullField mandatory
	}

	EnterCriticalSection(&PluginVideoCrit); // protect current thread

	/* Process current frame */
	if (!bIsOdd)
	{
		/* Process current Even frame */
		for (y = 0; y < maxY; y++)
		{ // Apply previous Even frame shiftings and get current Even frame pointers into global table
			if (bFirstEvenSkipped)
			{ // Apply previous Even frame shiftings exept if first one
				dx = cFrame[y*2]; // get current line shifting value from previous Even frame
				vidPlug.OutEvenLines[CurrentFrame][y] = pLA[y*2] + dx; // return adapted current line pointer
			}
			else
			{ // Special process for the first Even frame
				vidPlug.OutEvenLines[CurrentFrame][y] = vidPlug.EvenLines[CurrentFrame][y]; // initialize first Even frame to display
			}

			pLA[y*2] = vidPlug.EvenLines[CurrentFrame][y]; // get current line from current Even frame
		}
		bFirstEvenSkipped = true; // force true, initialized to false in Start()
	}
	else
	{
		/* Process current Odd frame */
		for (y = 0; y < maxY; y++)
		{ // Get current Odd frame pointers into global table
			pLA[y*2+1] = vidPlug.OddLines[CurrentFrame][y]; // get current line from current Odd frame
		}

		if (bFirstEvenSkipped)
			DecryptFrame(); // decrypt current pair of frames

		for (y = 0; y < maxY; y++)
		{ // Apply current Odd frame shiftings
			dx = cFrame[y*2+1]; // get current line shifting value
			vidPlug.OutOddLines[CurrentFrame][y] = pLA[y*2+1] + dx; // return adapted current line pointer
		}
	}

	// Hide special lines
	if (bIsOdd)
	{
		pOutLA = vidPlug.OutOddLines[CurrentFrame]; // current frame is Odd => map output Odd frame lines table
		pOutLA[0] = pOutLA[1]; // copy O1 in O0
		pOutLA[286] = pOutLA[285]; // copy O285 in O286
		pOutLA[287] = pOutLA[285]; // copy O285 in O287
	}
	else
	{
		pOutLA = vidPlug.OutEvenLines[CurrentFrame]; // current frame is Even => map output Even frame lines table
		pOutLA[0] = pOutLA[2]; // copy E2 in E0
		pOutLA[1] = pOutLA[2]; // copy E2 in E1
		pOutLA[287] = pOutLA[286]; // copy E286 in E287
	}

	*UpdateBuffer = true; // copy previous Even frame or current Odd frame
	*ViewBuffer = !bIsOdd; // display both frames after Odd frame processing, postposed to the next Even frame

	LeaveCriticalSection(&PluginVideoCrit); // unprotect current thread
}

/*
 Vrif quelconque
*/
void CheckStuff(void)
{
}	

/*
 Affichage dans la barre des status K!TV
*/
void GetStatus(char * Text, BOOL Nb)
{
	if (Nb)
		sprintf(Text,"X:%d, Y:%d, FullField:%d", vidPlug.CurrentX, maxY * (vidPlug.FullField + 1), vidPlug.FullField);
	else
		strcpy(Text, "KAzertix04e : Discret FF descrambling");
	return;
}

/*
 Pour y envoyer les messages le concernant (raccoucis clavier ddis au plugin)
*/
BOOL ProcessMessage(UINT message, UINT wParam, LONG lParam, char *OSDDisplay)
{
	return false;
}

/*
 Modifie le menu principal au lancement
*/
HMENU GetPluginMenu(BOOL ContextMenu)
{
	return NULL;
}

/*
 Truc standard pas bien utile
*/
void SetLow(unsigned char bBrightness)
{
}

/*
 Acclre le truc en supprimant le haut et le bas.
 Ce plugin devrait donc dtecter les ligne noires
 et s'il y en a, retourner true et changer la 
 valeur de vidPlug.MovieBoost.
*/
BOOL AutoMovieBoostFound()
{
	return false;
}

/*
 Pour la dtection automatique du type de cryptage
*/
BOOL DetecteSignal(BYTE *VBI)
{
	return false;
}
